<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2006 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
if (!defined("IN_FUSION")) { header("Location: ../index.php"); exit; }

function mtr_get_data($f_read = "", $t_read = "") {
	global $db_prefix, $forum_id, $data, $lastvisited;

	if (isset($forum_id) && !empty($forum_id)) { $forum_id = $forum_id; }
	elseif (isset($data['forum_id']) && !empty($data['forum_id'])) { $forum_id = $data['forum_id']; }
	$forum_read = $f_read === "all" || isNum($f_read) ? $f_read : 0;
	$thread_read = isNum($t_read) ? $t_read : 0;
	$read = array(); $unread = array();
	if (!isset($_COOKIE['fusion_mtr']) || $forum_read === "all") {
		$result = dbquery("SELECT forum_id FROM ".$db_prefix."forums WHERE ".groupaccess('forum_access')." AND forum_cat != '0'");
		if (dbrows($result) != 0) {
			$cookie_data = "";
			while($data = dbarray($result)) {
				if ($forum_read == "all" || $forum_read == $data['forum_id']) {
					$read[$data['forum_id']][0] = time();
					$cookie_data .= ($cookie_data == "" ? "" : "_").$data['forum_id'].".0.".time();
				} else { 
					$read[$data['forum_id']][0] = $lastvisited;
					$cookie_data .= ($cookie_data == "" ? "" : "_").$data['forum_id'].".0.{$lastvisited}";
				}
			}
			if (!empty($thread_read)) {
				$read[$forum_id][$thread_read] = time();
				$cookie_data .= ($cookie_data == "" ? "" : "_")."{$forum_id}.{$thread_read}.".time();
			}
			setcookie("fusion_mtr", $cookie_data, time() + 7776000, "/", "", "0");
		}
	} else {
		$temp = explode("_", $_COOKIE['fusion_mtr']);
		$unread_temp = array();
		for($i = 0; $i < count($temp); $i ++) {
			$temp2 = explode(".", $temp[$i]);
			if ($temp2[0] == "u" && isNum($temp2[1]) && !empty($temp2[1]) && isNum($temp2[2]) && !empty($temp2[2]) && isNum($temp2[3]) && !empty($temp2[3])) {
				$unread_temp[$temp2[1]][$temp2[2]] = $temp2[3];
			} elseif (isNum($temp2[0]) && !empty($temp2[0]) && isNum($temp2[1]) && isNum($temp2[2])) {
				$read[$temp2[0]][$temp2[1]] = $temp2[2];
			}
		}
		if (!empty($forum_read)) {
			$read[$forum_read] = array(0 => time());
			unset($unread_temp[$forum_read]);
		}
		if (!empty($thread_read)) { $read[$forum_id][$thread_read] = time(); }
		$result = dbquery("SELECT forum_id FROM ".$db_prefix."forums WHERE ".groupaccess('forum_access')." AND forum_cat != '0'");
		if (dbrows($result) != 0) {
			while($data = dbarray($result)) {
				if (!isset($read[$data['forum_id']][0])) { $read[$data['forum_id']][0] = $lastvisited; }
			}
		}
		foreach($unread_temp as $forum_key => $temp_array) {
			foreach($temp_array as $thread_key => $value) {
				if (!isset($read[$forum_key][$thread_key]) || $read[$forum_key][$thread_key] < $value) {
					unset($read[$forum_key][$thread_key]);
					$unread[$forum_key][$thread_key] = $value;
				}
			}
		}
		if (FUSION_SELF == "index.php") {
			$result = dbquery("SELECT forum_id FROM ".$db_prefix."forums WHERE ".groupaccess('forum_access')." AND forum_cat != '0'");
			if (dbrows($result) != 0) {
				while(list($forum_id) = dbarraynum($result)) {
					$result2 = dbquery("SELECT thread_id, thread_lastpost FROM ".$db_prefix."threads
						WHERE thread_lastpost > '".$read[$forum_id][0]."' ORDER BY thread_lastpost ASC"
					);
					if (dbrows($result2) != 0) {
						$threads = array();
						while($data = dbarray($result2)) { $threads[] = array($data['thread_id'], $data['thread_lastpost']); }
						for($i = 0; $i < count($threads); $i ++) {
							if (isset($read[$forum_id][$threads[$i][0]]) && $read[$forum_id][$threads[$i][0]] >= $threads[$i][1]) {
								$read[$forum_id][0] = $threads[$i][1];
								unset($read[$forum_id][$threads[$i][0]]);
							} else { break; }
						}
						reset($threads);
						for($i = 0; $i < count($threads); $i ++) {
							if (isset($read[$forum_id][$threads[$i][0]]) && $read[$forum_id][$threads[$i][0]] < $threads[$i][1]) {
								unset($read[$forum_id][$threads[$i][0]]);
							}
						}
					}
				}
			}
		} else { 
			$result = dbquery("SELECT thread_id, thread_lastpost FROM ".$db_prefix."threads
				WHERE thread_lastpost > '".$read[$forum_id][0]."' ORDER BY thread_lastpost ASC"
			);
			if (dbrows($result) != 0) {
				$threads = array();
				while($data = dbarray($result)) { $threads[] = array($data['thread_id'], $data['thread_lastpost']); }
				for($i = 0; $i < count($threads); $i ++) {
					if (isset($read[$forum_id][$threads[$i][0]]) && $read[$forum_id][$threads[$i][0]] >= $threads[$i][1]) {
						$read[$forum_id][0] = $threads[$i][1];
						unset($read[$forum_id][$threads[$i][0]]);
					} else { break; }
				}
				reset($threads);
				for($i = 0; $i < count($threads); $i ++) {
					if (isset($read[$forum_id][$threads[$i][0]]) && $read[$forum_id][$threads[$i][0]] < $threads[$i][1]) {
						unset($read[$forum_id][$threads[$i][0]]);
					}
				}
			}
		}
		$temp = array();
		foreach($read as $forum_key => $temp_array) {
			foreach($temp_array as $thread_key => $value) {
				$temp[] = "$forum_key.$thread_key.$value";
			}
		}
		foreach($unread as $forum_key => $temp_array) {
			foreach($temp_array as $thread_key => $value) {
				$temp[] = "u.$forum_key.$thread_key.$value";
			}
		}
		$cookie_data = implode("_", $temp);
		setcookie("fusion_mtr", $cookie_data, time() + 7776000, "/", "", "0");
	}
	return array("read" => $read, "unread" => $unread);
}

function mtr_set_thread_image() {
	global $locale, $forum_id, $data, $mtr;
		
	if (isset($mtr['read'][$forum_id][$data['thread_id']]) && $mtr['read'][$forum_id][$data['thread_id']] > $mtr['read'][$forum_id][0]) {
		$read = $mtr['read'][$forum_id][$data['thread_id']];
	} else { $read = $mtr['read'][$forum_id][0]; }
	$unread = isset($mtr['unread'][$forum_id][$data['thread_id']]) ? $mtr['unread'][$forum_id][$data['thread_id']] : 0;
	if ($read < $data['thread_lastpost'] || $unread > $data['thread_lastpost']) {
		$image = "<a href='javascript:void(0)' onClick=\"mtr_mark_thread($forum_id, ".$data['thread_id'].", ".$data['thread_lastpost'].");\"><img src='".THEME."forum/foldernew.gif' alt='".$locale['560']."' border='0' id='unread".$data['thread_id']."' title='".$locale['MTR_000']."'><img src='".THEME."forum/folder.gif' alt='".$locale['561']."' border='0' id='read".$data['thread_id']."' title='".$locale['MTR_001']."' style='display: none;'></a>";
	} else {
		$image = "<a href='javascript:void(0)' onClick=\"mtr_mark_thread($forum_id, ".$data['thread_id'].", ".$data['thread_lastpost'].");\"><img src='".THEME."forum/foldernew.gif' alt='".$locale['560']."' border='0' id='unread".$data['thread_id']."' title='".$locale['MTR_000']."' style='display: none;'><img src='".THEME."forum/folder.gif' alt='".$locale['561']."' border='0' id='read".$data['thread_id']."' title='".$locale['MTR_001']."'></a>";
	}
	return $image;
}

function mtr_set_forum_image() {
	global $locale, $data, $mtr;

	if ($mtr['read'][$data['forum_id']][0] < $data['last_post'] || (isset($mtr['unread'][$data['forum_id']]) && count($mtr['unread'][$data['forum_id']]) != 0)) {
		$image = "<a href='javascript:void(0)' onClick=\"mtr_mark_forum(".$data['forum_id'].");\"><img src='".THEME."forum/foldernew.gif' alt='".$locale['560']."' border='0' id='unread".$data['forum_id']."' title='".$locale['MTR_000']."'><img src='".THEME."forum/folder.gif' alt='".$locale['561']."' border='0' id='read".$data['forum_id']."' title='".$locale['MTR_001']."' style='display: none;'></a>";
	} else {
		$image = "<a href='javascript:void(0)' onClick=\"mtr_mark_forum(".$data['forum_id'].");\"><img src='".THEME."forum/foldernew.gif' alt='".$locale['560']."' border='0' id='unread".$data['forum_id']."' title='".$locale['MTR_000']."' style='display: none;'><img src='".THEME."forum/folder.gif' alt='".$locale['561']."' border='0' id='read".$data['forum_id']."' title='".$locale['MTR_001']."'></a>";
	}
	return $image;
}

function mtr_set_ftlp_image() {
	global $locale, $data, $mtr, $imageold, $imagenew, $imagehot;

	if (isset($mtr['read'][$data['forum_id']][$data['thread_id']]) && $mtr['read'][$data['forum_id']][$data['thread_id']] > $mtr['read'][$data['forum_id']][0]) {
		$read = $mtr['read'][$data['forum_id']][$data['thread_id']];
	} else { $read = $mtr['read'][$data['forum_id']][0]; }
	$unread = isset($mtr['unread'][$data['forum_id']][$data['thread_id']]) ? $mtr['unread'][$data['forum_id']][$data['thread_id']] : 0;
	if ($read < $data['thread_lastpost'] || $unread > $data['thread_lastpost']) {
		$image = "<a href='javascript:void(0)' onClick=\"mtr_mark_thread(".$data['forum_id'].", ".$data['thread_id'].", ".$data['thread_lastpost'].");\"><img src='$imagenew' alt='".$locale['MTR_002']."' border='0' id='unread".$data['thread_id']."' title='".$locale['MTR_000']."'><img src='".($data['count_posts'] > 20 ? $imagehot : $imageold)."' alt='".$locale['MTR_003']."' border='0' id='read".$data['thread_id']."' title='".$locale['MTR_001']."' style='display: none;'></a>";
	} else {
		$image = "<a href='javascript:void(0)' onClick=\"mtr_mark_thread(".$data['forum_id'].", ".$data['thread_id'].", ".$data['thread_lastpost'].");\"><img src='$imagenew' alt='".$locale['MTR_002']."' border='0' id='unread".$data['thread_id']."' title='".$locale['MTR_000']."' style='display: none;'><img src='".($data['count_posts'] > 20 ? $imagehot : $imageold)."' alt='".$locale['MTR_003']."' border='0' id='read".$data['thread_id']."' title='".$locale['MTR_001']."'></a>";
	}
	return $image;
}

?>