function mtr_get_cookie(name) {
	var start = document.cookie.indexOf(name + '=');
	var len = start + name.length + 1;
	if ((!start) && (name != document.cookie.substring(0, name.length))) {
		return null;
	}
	if (start == -1) { return null; }
	var end = document.cookie.indexOf(';', len);
	if ( end == -1 ) { end = document.cookie.length; }
	return unescape(document.cookie.substring(len, end));
}

function mtr_set_cookie(name, value, expires, path, domain, secure) {
	var today = new Date();
	today.setTime(today.getTime());
	if (expires) { expires = expires * 1000 * 60 * 60 * 24; }
	var expires_date = new Date(today.getTime() + (expires));
	document.cookie = name + '=' + escape(value) + ((expires) ? ';expires=' + expires_date.toGMTString() : '') + ((path) ? ';path=' + path : '') + ((domain) ? ';domain=' + domain : '') + ((secure) ? ';secure' : '');
}

function mtr_mark_thread(forum, thread, lastpost) {
	var lastread = 0;
	var cookie_data = '';
	var temp = mtr_get_cookie('fusion_mtr');
	if (temp != null) {
		var temp2 = temp.split('_');
		for(i = 0; i < temp2.length; i ++) {
			temp3 = temp2[i].split('.');
			if (temp3[0] == 'u') {
				if (temp3[1] != forum || temp3[2] != thread) {
					if (cookie_data != '') { cookie_data = cookie_data + '_'; }
					cookie_data = cookie_data + 'u.' + temp3[1] + '.' + temp3[2] + '.' + temp3[3];
				}
			} else {
				if (temp3[0] == forum && temp3[1] == 0) { lastread = temp3[2]; }
				if (temp3[0] != forum || temp3[1] != thread) {
					if (cookie_data != '') { cookie_data = cookie_data + '_'; }
					cookie_data = cookie_data + temp3[0] + '.' + temp3[1] + '.' + temp3[2];
				}
			}
		}
	}
	if (document.getElementById('read' + thread).style.display == 'none') {
		if (lastpost > lastread) {
			var now = new Date();
			var seconds = Math.round(now.getTime() / 1000);
			if (cookie_data != '') { cookie_data = cookie_data + '_'; }
			cookie_data = cookie_data + forum + '.' + thread + '.' + seconds;
		}
	} else {
		if (lastpost <= lastread) {
			var now = new Date();
			var seconds = Math.round(now.getTime() / 1000);
			if (cookie_data != '') { cookie_data = cookie_data + '_'; }
			cookie_data = cookie_data + 'u.' + forum + '.' + thread + '.' + seconds;
		}
	}
	mtr_image_toggle(thread);
	mtr_set_cookie('fusion_mtr', cookie_data, 90, '/', '', 0);
}

function mtr_mark_forum(forum) {
	var lastread = 0;
	var cookie_data = '';
	var temp = mtr_get_cookie('fusion_mtr');
	if (temp != null) {
		var temp2 = temp.split('_');
		for(i = 0; i < temp2.length; i ++) {
			temp3 = temp2[i].split('.');
			if (temp3[0] == 'u') {
				if (temp3[1] != forum) {
					if (cookie_data != '') { cookie_data = cookie_data + '_'; }
					cookie_data = cookie_data + 'u.' + temp3[1] + '.' + temp3[2] + '.' + temp3[3];
				}
			} else {
				if (temp3[0] == forum) { lastread = temp3[2]; }
				if (temp3[0] != forum) {
					if (cookie_data != '') { cookie_data = cookie_data + '_'; }
					cookie_data = cookie_data + temp3[0] + '.' + temp3[1] + '.' + temp3[2];
				}
			}
		}
	}
	if (document.getElementById('read' + forum).style.display == 'none') {
		var now = new Date();
		var seconds = Math.round(now.getTime() / 1000);
		if (cookie_data != '') { cookie_data = cookie_data + '_'; }
		cookie_data = cookie_data + forum + '.0.' + seconds;
	} else {
		if (cookie_data != '') { cookie_data = cookie_data + '_'; }
		cookie_data = cookie_data + forum + '.0.0';
	}
	mtr_image_toggle(forum);
	mtr_set_cookie('fusion_mtr', cookie_data, 90, '/', '', 0);
}

function mtr_image_toggle(id) {
	var read = document.getElementById('read' + id);
	var unread = document.getElementById('unread' + id);
	if (read.style.display == 'none') {
		read.style.display = '';
		unread.style.display = 'none';
	} else {
		read.style.display = 'none';
		unread.style.display = '';
	}
}